package WebDP::SimpleTemplate;
use strict;
use FileHandle;

sub new {
    my($class, $file) = @_;
    bless {
        vars => {},
        file => $file,
    }, $class;
}

sub fill {
    my($self, %vars) = @_;
    while (my($k, $v) = each %vars) {
        $self->{vars}->{$k} = $v;
    }
}

sub output {
    my $self = shift;
    my $body = $self->_read_template;
    $body =~ s{<%\s+(\w+)\s+%>}{
        $self->{vars}->{$1} || ''
    }eg;
    return $body;
}

sub _read_template {
    my $self = shift;
    my $handle = FileHandle->new($self->{file})
        or die "$self->{file}: $!";
    local $/;
    return <$handle>;
}

1;
