package WebDP::Album::Folder;
use strict;

use vars qw($FolderDir);
$FolderDir = "data";

use DirHandle;
use FileHandle;
use WebDP::Album::Image;

sub available {
    my $class = shift;
    my $dir   = DirHandle->new($FolderDir)
        or die "$FolderDir: $!";
    return map $class->new($_),
        grep !/^\./, $dir->read;
}

sub new {
    my($class, $dirname) = @_;
    bless { dirname => $dirname }, $class;
}

sub name { shift->{dirname} }
sub dir  { "$FolderDir/" . shift->{dirname}; }

sub images {
    my $self = shift;
    my $dir  = DirHandle->new($self->dir)
        or die $self->dir . ": $!";
    return map WebDP::Album::Image->new($_, $self),
        grep -f $self->dir . "/$_", $dir->read;
}

sub number {
    my $self = shift;
    my @files = $self->images;
    return scalar @files;
}

sub updated {
    my $self = shift;
    return scalar localtime($self->modtime);
}

sub modtime {
    my $self = shift;
    return (stat($self->dir))[9];
}

1;
