#!/usr/local/bin/perl -wT
use strict;
use lib '.';
use CGI;
use WebDP::Album::Folder;
use WebDP::Template::HT;

my $query = CGI->new;
do_task($query);

sub do_task {
    my $query = shift;
    my $name = ($query->param('name') =~ /^(\w+)$/)[0]  # #1
        or die "name not found.";                        #
    my $folder   = WebDP::Album::Folder->new($name);

    my @images   = $folder->images;
    my $break_count = 0;
    my @tmpl_images = map {
        $break_count++;
        +{                                                #
            src  => $_->src,                                #
            name => $_->name,                                # #2
            break_line => ($break_count % 4 == 0),        #
        };
    } @images;

    my $template = WebDP::Template::HT->new('list');
    $template->fill(
        name   => $folder->name,
        images => \@tmpl_images,
    );
    print $query->header(-charset => 'euc-jp'), $template->output;
}
